#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <cstdlib>
#include <cmath>
using namespace std;

void done(double score, string message) {
	cout << score << "\n";
	cerr << message << "\n";
	exit(0);
}

int n;
vector<int> k;

int diff(int n1, int n2) {
	int d = 0;
	for (int i = 0; i < n; ++i) {
		if (i < n1 || i >= n - n2) {
			d += k[i];
		} else {
			d -= k[i];
		}
	}
	return abs(d);
}

int main(int argc, const char *argv[]) {
	if (argc != 4) {
		cerr << "Usage: " << argv[0] << " input_file hint_file output_file\n";
		return 0;
	}
	ifstream in(argv[1]), hint(argv[2]), out(argv[3]);

	in >> n;
	k.resize(n);
	for (int i = 0; i < n; ++i) {
		in >> k[i];
	}

	int h1, h2;
	hint >> h1 >> h2;

	int n1, n2;
	out >> n1 >> n2;
	if (!out) {
		done(0, "Invalid output file");
	}
	if (0 > n1 || n1 > n || 0 > n2 || n2 > n || n1 + n2 > n) {
		done(0, "Wrong answer");
	}
	string tmp;
	out >> tmp;
	if (out) {
		done(0, "Invalid output file");
	}

	int hd = diff(h1, h2);
	int nd = diff(n1, n2);
	if (nd < hd) {
		done(1, "Wrong hint!");
	} else if (nd == hd) {
		done(1, "OK");
	} else {
		done(0, "Wrong answer");
	}
}
