# -- coding: utf-8 --

# O(NlogN) lahendus, mis leiab iga N2 jaoks parima N1 kahendotsinguga

import bisect # ise kirjutamise asemel kasutame standardteegi kahendotsingut

with open('kuklsis.txt', 'rt') as sis:
	n = int(sis.readline().strip())
	k = [int(sis.readline().strip()) for _ in range(n)]

# summa[i] on karpides 1..i olevate kuklite koguarv
summa = [0] * (n + 1)
for i in range(n):
	summa[i + 1] = summa[i] + k[i]

# seni parim tulemus
parim_n1 = 0
parim_n2 = 0
parim_vahe = sum(k) + 1

# kontrollib, kas (N1, N2) on parem kui senine parim tulemus
def proovi(n1, n2):
	global parim_n1, parim_n2, parim_vahe
	mari = summa[n - n2] - summa[n1]
	juri = summa[n] - mari
	if abs(juri - mari) < parim_vahe:
		parim_n1 = n1
		parim_n2 = n2
		parim_vahe = abs(juri - mari)

for n2 in range(n + 1):
	# kui palju peaks n1 vasaku elemendi summa olema, et
	# need n2 paremaga kokku annaks poole üldsummast?
	vaja = summa[n - n2] - summa[n] / 2
	# leiame kahendotsinguga n1 kandidaadid
	n1 = bisect.bisect_right(summa, vaja, 0, n - n2)
	if n1 > 0:
		proovi(n1 - 1, n2)
	proovi(n1, n2)

with open('kuklval.txt', 'wt') as val:
	val.write('{} {}\n'.format(parim_n1, parim_n2))
