// O(NlogN) lahendus, mis leiab iga N2 jaoks parima N1 kahendotsinguga

// laiendatud versioon: lisaks lahendamisele väljastab ka statistikat

#include <iostream>
#include <fstream>
#include <vector>
#include <cmath>
#include <algorithm>
using namespace std;

ifstream sis("kuklsis.txt");
ofstream val("kuklval.txt");

// sisendandmed
int n;
vector<int> k;

// seni parim tulemus
int parim_n1;
int parim_n2;
int parim_vahe;

// summa[i] on karpides 1..i olevate kuklite koguarv
vector<int> summa;

// statistika
int parim_kordi;
int parim_n1_null;
int parim_n2_null;

void proovi(int n1, int n2, int k) {
	int mari = summa[n - n2] - summa[n1];
	int juri = summa[n] - mari;
	if (parim_vahe > abs(juri - mari)) {
		parim_n1 = n1;
		parim_n2 = n2;
		parim_vahe = abs(juri - mari);
		parim_kordi = 0;
		parim_n1_null = 0;
		parim_n2_null = 0;
	}
	if (parim_vahe == abs(juri - mari)) {
		parim_kordi += k;
		if (n1 == 0) parim_n1_null += 1;
		if (n2 == 0) parim_n2_null += k;
	}
}

int main() {
	sis >> n;
	k.resize(n);
	for (int i = 0; i < n; ++i) {
		sis >> k[i];
	}

	summa.resize(n + 1);
	summa[0] = 0;
	for (int i = 0; i < n; ++i) {
		summa[i + 1] = summa[i] + k[i];
	}

	parim_vahe = summa[n] + 1;
	for (int n2 = 0; n2 <= n; ++n2) {
		// kui palju peaks n1 vasaku elemendi summa olema, et
		// need n2 paremaga kokku annaks poole üldsummast?
		// paaritu üldsumma korral ümardame alla
		int vaja = summa[n - n2] - (summa[n] + 1) / 2;
		// leiame kahendotsinguga n1 kandidaadid
		int i1 = upper_bound(summa.begin(), summa.end() - n2, vaja) - summa.begin();
		if (i1 > 0) {
			int i0 = lower_bound(summa.begin(), summa.end() - n2, summa[i1 - 1]) - summa.begin();
			proovi(i0, n2, i1 - i0);
		}
		int i2 = upper_bound(summa.begin(), summa.end() - n2, summa[i1]) - summa.begin();
		proovi(i1, n2, i2 - i1);
	}

	val << parim_n1 << ' ' << parim_n2 << '\n';
	cout << "D = " << parim_vahe << ", " << parim_kordi << "x";
	if (parim_n1_null > 0) cout << ", N1 " << parim_n1_null << "x";
	if (parim_n2_null > 0) cout << ", N2 " << parim_n2_null << "x";
	cout << '\n';
}
