#include "testlib.h"
#include <iostream>
#include <assert.h>

using namespace std;

int main (int argc, char **argv) {
  registerGen(argc, argv, 1);

  assert(argc > 5);
  int n = atoi(argv[1]); // # of vertices
  int k = atoi(argv[2]); // # of groups
  int wa = atoi(argv[3]); // max width of prev search, 1st stage
  int wb = atoi(argv[4]); // max width of prev search, 2nd stage
  assert(n % k == 0);

  vector<pair<int, int>> edges;
  int m = n / k; // group size
  for (int i = 0; i < n; i += m) {
    for (int j = i + 1; j < i + m; j++) {
      edges.push_back(make_pair(rnd.next(max(i, j - wa), j - 1), j));
    }
  }

  for (int i = m; i < n; i += m) {
    edges.push_back(make_pair(rnd.next(max(0, i - wb), i - 1), rnd.next(i, i + m - 1)));
  }

  vector<int> perm;
  for (int i = 1; i <= n; i++) {
    perm.push_back(i);
  }

  shuffle(perm.begin(), perm.end());
  shuffle(edges.begin(), edges.end());
  for (int i = 0; i < (int) edges.size(); i++) {
    if (rnd.next(0, 1) == 0) {
      swap(edges[i].first, edges[i].second);
    }
  }

  cout << n << " " << k << endl;
  for (auto e : edges) {
    cout << perm[e.first] << " " << perm[e.second] << endl;
  }
}
