# sisendi korrektsuse kontrollija

import sys

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

n, k = [int(_) for _ in fi.readline().strip().split()]
if 1 > n or n > 3e5:
	sys.exit('N out of range')
if 1 > k or k > n:
	sys.exit('K out of range')
fo.write('{0} {1}\n'.format(n, k))

s = set()
for i in range(n -1):
	(a, b) = [int(_) for _ in fi.readline().split()]
	if 1 > a or a > n:
		sys.exit('U[{0}] out of range'.format(1 + i))
	if 1 > b or b > n:
		sys.exit('V[{0}] out of range'.format(1 + i))
	if a == b:
		sys.exit('Self-loop on line {0}'.format(2 + i))
	if (a, b) in s or (b, a) in s:
		sys.exit('Duplicate street on line {0}'.format(2 + i))
	s.add((a, b))
	fo.write('{0} {1}\n'.format(a, b))

def root(x):
	global roots
	if roots[x] != x:
		roots[x] = root(roots[x])
	return roots[x]

def join(x, y):
	global roots
	roots[root(x)] = root(y)

roots = [_ for _ in range(n)]
for a, b in s:
	if root(a - 1) != root(b - 1):
		join(a - 1, b - 1)
for r in range(n):
	if root(r) != root(0):
		sys.exit('Street network not connected')

fi.close()
fo.close()

if len(sys.argv) > 3 and sys.argv[3] == '-v':
	if k == 2 and n <= 1e3:
		print('subtask 1')
	elif k == 2:
		print('subtask 2')
	elif n <= 1e3:
		print('subtask 3')
	else:
		print('subtask 4')
