#include "testlib.h"
#include <iostream>
#include <assert.h>

using namespace std;

int main (int argc, char **argv) {
  registerGen(argc, argv, 1);

  assert(argc > 4);
  int n = atoi(argv[1]); // # of vertices
  int k = atoi(argv[2]); // # of groups
  int w = atoi(argv[3]); // max width of prev search
  
  vector<pair<int, int>> edges;
  for (int i = 1; i < n; i++) {
    edges.push_back(make_pair(rnd.next(max(0, i - w), i - 1), i));
  }
  
  vector<int> perm;
  for (int i = 1; i <= n; i++) {
    perm.push_back(i);
  }

  shuffle(perm.begin(), perm.end());
  shuffle(edges.begin(), edges.end());
  for (int i = 0; i < (int) edges.size(); i++) {
    if (rnd.next(0, 1) == 0) {
      swap(edges[i].first, edges[i].second);
    }
  }

  cout << n << " " << k << endl;
  for (auto e : edges) {
    cout << perm[e.first] << " " << perm[e.second] << endl;
  }
}
