#include <fstream>
#include <vector>
#include <map>

using namespace std;

ifstream fi("tyksis.txt");
ofstream fo("tykval.txt");

const int MAX_N = 3e5 + 5;

vector<int> adj [MAX_N];
int subtree_size [MAX_N];

void calc_size (int u, int p) {
  subtree_size[u] = 1;
  for (int nxt : adj[u]) {
    if (nxt != p) {
      calc_size(nxt, u);
      subtree_size[u] += subtree_size[nxt];
    }
  }
}

int piece_size;
int group [MAX_N];
int cnt_group [MAX_N];
void assign (int u, int p, int _group) {
  group[u] = _group;
  cnt_group[group[u]]++;
  for (int nxt : adj[u]) {
    if (nxt != p) {
      if (subtree_size[nxt] % piece_size == 0) {
        assign(nxt, u, nxt);
      } else {
        assign(nxt, u, _group);
      }
    }
  }
}

int main () {
  int n, k;
  fi >> n >> k;

  if (n % k != 0) {
    fo << "EI SAA" << endl;
    return 0;
  }
  piece_size = n / k;
  
  for (int i = 0; i < n - 1; i++) {
    int u, v;
    fi >> u >> v;

    adj[u].push_back(v);
    adj[v].push_back(u);
  }

  calc_size(1, 1);
  assign(1, 1, 1);

  map<int, int> id;
  int cnt = 1;
  for (int i = 1; i <= n; i++) {
    if (group[i] == i) {
      if (cnt_group[i] != piece_size) {
        fo << "EI SAA" << endl;
        return 0;
      }

      id[i] = cnt;
      cnt++;
    }
  }

  fo << "SAAB" << endl;
  for (int i = 1; i <= n; i++) {
    fo << id[group[i]] << " ";
  }
  fo << endl;
}
