# sisendi korrektsuse kontrollija

import sys

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

n, q = [int(_) for _ in fi.readline().strip().split()]
if 1 > n or n > 100000:
	sys.exit('N out of range')
if 1 > q or q > 100000:
	sys.exit('Q out of range')
fo.write('{0} {1}\n'.format(n, q))

def read(num, off, uni):
	rr, gg, bb = 0, 0, 0
	ss = set()
	for i in range(num):
		r, g, b = [int(_) for _ in fi.readline().strip().split()]
		if 0 > r or r > 65535:
			sys.exit('R out of range on line {0}'.format(off + i))
		rr = max(rr, r)
		if 0 > g or g > 65535:
			sys.exit('G out of range on line {0}'.format(off + i))
		gg = max(gg, g)
		if 0 > b or b > 65535:
			sys.exit('B out of range on line {0}'.format(off + i))
		bb = max(bb, b)
		if uni:
			if (r, g, b) in ss:
				sys.exit('Duplicate colot on line {0}'.format(off + i))
			ss.add((r, g, b))
		fo.write('{0} {1} {2}\n'.format(r, g, b))
	return rr, gg, bb

r1, g1, b1 = read(n, 2, True)
r2, g2, b2 = read(q, 2 + n, False)

if r2 > 0 and r1 == 0:
	sys.stderr.write('Warning: No R in machine, but queries ask for it\n')
if g2 > 0 and g1 == 0:
	sys.stderr.write('Warning: No G in machine, but queries ask for it\n')
if b2 > 0 and b1 == 0:
	sys.stderr.write('Warning: No B in machine, but queries ask for it\n')

fi.close()
fo.close()

if len(sys.argv) > 3 and sys.argv[3] == '-v':
	if g1 == g2 == b1 == b2 == 0:
		if n <= 25000 and q <= 10000:
			print('subtask 1')
		elif q <= 50000:
			print('subtask 2')
		else:
			print('subtask 3')
	elif b1 == b2 == 0:
		if n <= 25000 and q <= 10000:
			print('subtask 4')
		elif q <= 50000:
			print('subtask 5')
		else:
			print('subtask 6')
	else:
		if n <= 25000 and q <= 10000:
			print('subtask 7')
		elif q <= 50000:
			print('subtask 8')
		elif q <= 75000:
			print('subtask 9')
		else:
			print('subtask 10')
