#include <iostream>
#include <algorithm>
#include <queue>
#include <fstream>

using namespace std;

class Varv
{
public:
	int Nr, R, G, B;
	Varv(int nr, int r, int g, int b);
};

Varv::Varv(int nr, int r, int g, int b)
{
	Nr = nr;
	R = r;
	G = g;
	B = b;
}

class Tipp
{
public:
	bool on_alluvaid = false, on_punkt = false;
	int X, Y, Z, S;
	Varv* varv = NULL;
	Tipp* alluvad[8]{ NULL };
	Tipp(int x, int y, int z, int s);
};

Tipp::Tipp(int x, int y, int z, int s)
{
	X = x;
	Y = y;
	Z = z;
	S = s;
}

void LisaPuusse2(Tipp* t, Varv* v)
{
	if (!(t->on_alluvaid)) {
		if (!(t->on_punkt)) {
			t->varv = v;
			t->on_punkt = true;
		}
		else {
			t->on_alluvaid = true;
			t->on_punkt = false;
			LisaPuusse2(t, t->varv);
			LisaPuusse2(t, v);
		}
	}
	else {
		int uuss = t->S / 2;
		int indeks = (v->R >= t->X + uuss) * 4 + (v->G >= t->Y + uuss) * 2 + (v->B >= t->Z + uuss);
		if (!(t->alluvad[indeks])) {
			Tipp * tuus = new Tipp(t->X + uuss * ((indeks & 4) > 0),
				t->Y + uuss * ((indeks & 2) > 0),
				t->Z + uuss * ((indeks & 1) > 0),
				uuss);
			t->alluvad[indeks] = tuus;
		}

		LisaPuusse2(t->alluvad[indeks], v);
	}
}

int leialahim(int c, int v, int s)
{
	if (c <= v && c + s > v) return 0;
	return c < v ? v - (c + s - 1) : c - v;
}

int leiakaugeim(int c, int v, int s)
{
	if (c <= v && c + s > v) return max(v - c, c + s - 1 - v);
	return c < v ? v - c : c + s - 1 - v;
}

int otsi(Tipp* t, Varv* v)
{
	priority_queue <pair<int, Tipp*>, vector<pair<int, Tipp*>>, greater<pair<int, Tipp*>>> jrkd;
	int nk = leiakaugeim(t->X, v->R, t->S) + leiakaugeim(t->Y, v->G, t->S) + leiakaugeim(t->Z, v->B, t->S);
	int kaugus = nk;
	int varvinr = 1000001;
	jrkd.push(make_pair(nk, t));
	int mitu = 0;
	while (!jrkd.empty()) {
		mitu++;
		t = jrkd.top().second;
		nk = jrkd.top().first;
		jrkd.pop();

		if (nk > kaugus) return varvinr;
		
		if (t->on_punkt) {
			if (nk == kaugus) varvinr = min(varvinr, t->varv->Nr);
			else if (nk < kaugus) {
				kaugus = nk;
				varvinr = t->varv->Nr;
			}
		}
		else {
			for (int i = 0; i < 8; i++) {
				if (!t->alluvad[i]) continue;
				int k;
				Tipp* ut = t->alluvad[i];
				if (ut->on_punkt) {
					k = abs(ut->varv->R - v->R) + abs(ut->varv->G - v->G) + abs(ut->varv->B - v->B);
					if (k == 0) return ut->varv->Nr;
					if (k <= kaugus) jrkd.push(make_pair(k, ut));
				}
				else if (ut->on_alluvaid) {
					k = leialahim(ut->X, v->R, ut->S) + leialahim(ut->Y, v->G, ut->S) + leialahim(ut->Z, v->B, ut->S);
					if (k <= kaugus) jrkd.push(make_pair(k, ut));
				}
			}
		}
	}
	return varvinr;
}

int main()
{
	ifstream cin;
	ofstream cout;
	cin.open("varvsis.txt");
	cout.open("varvval.txt");
	int N, Q, C = 1 << 16;
	cin >> N >> Q;

	Tipp juur(0, 0, 0, C);
    int r, g, b;

	for (int i = 0; i < N; i++){
		cin >> r >> g >> b;
		Varv * v = new Varv(i, r, g, b);
		LisaPuusse2(&juur, v);
	}

	for (int i = 0; i < Q; i++) {
		cin >> r >> g >> b;
		Varv vk(0, r, g, b);
		cout << otsi(&juur, &vk) << "\n";
	}
	cin.close();
	cout.close();
}